<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <div class="query-box">
        <div class="query-box__left">
          <el-form-item prop="communityId">
            <el-select
              v-model="queryParams.communityId"
              filterable
              placeholder="请选择医共体"
            >
              <el-option
                v-for="item in cimmunity"
                :key="item.id"
                :label="item.name"
                :value="item.id"
                :disabled="item.state == 1 ? false : true"
              >
              </el-option>
            </el-select>
          </el-form-item>

          <el-form-item prop="mechanismId">
            <el-select
              v-model="queryParams.mechanismId"
              filterable
              placeholder="请选择医疗机构"
            >
              <el-option
                v-for="item in mechanismArr"
                :key="item.id"
                :label="item.name"
                :value="item.id"
                :disabled="item.state == 1 ? false : true"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="" prop="name">
            <el-input
              v-model="queryParams.name"
              placeholder="请输入科室名称"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item>
            <el-button
              type="primary"
              icon="el-icon-search"
              size="mini"
              @click="handleQuery"
              >搜索</el-button
            >
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
              >重置</el-button
            >
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              v-hasPermi="['medical:dept:add']"
              >新增</el-button
            >
          </el-form-item>
        </div>
      </div>
    </el-form>

    <!-- <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['medical:dept:add']"
          >新增</el-button
        >
      </el-col>
    </el-row> -->

    <el-table
      v-loading="loading"
      :data="deptList"
      @selection-change="handleSelectionChange"
      border
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" width="55" align="center" label="序号" />
      <el-table-column label="医共体名称" align="center" prop="communityName" />
      <el-table-column
        label="医疗机构名称"
        align="center"
        prop="mechanismName"
      />
      <el-table-column label="科室名称" align="center" prop="name" />
      <el-table-column label="科室类型" align="center" prop="type">
        <template slot-scope="scope">
          <dict-tag :options="typeOptions" :value="scope.row.type" />
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="primary"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['medical:dept:edit']"
            style="width: 40px"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="primary"
            @click="handleDelete(scope.row)"
            v-hasPermi="['medical:dept:remove']"
            style="width: 40px"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改科室病区对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item prop="communityId" label="医共体名称">
          <el-select
            v-model="form.communityId"
            filterable
            placeholder="请选择医共体"
            @change="handleChangeCommunity"
            style="width: 100%"
          >
            <el-option
              v-for="item in cimmunity"
              :key="item.id"
              :label="item.name"
              :value="item.id"
              :disabled="item.state == 1 ? false : true"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="医疗机构名称" prop="mechanismId">
          <el-form-item prop="mechanismId">
            <el-select
              v-model="form.mechanismId"
              filterable
              placeholder="请选择医疗机构"
              style="width: 100%"
            >
              <el-option
                v-for="item in mechanism"
                :key="item.id"
                :label="item.name"
                :value="item.id"
                style="width: 100%"
                :disabled="item.state == 1 ? false : true"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-form-item>

        <el-form-item label="科室名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="科室类别" prop="type">
          <el-select
            v-model="form.type"
            placeholder="请选择类别"
            style="width: 100%"
          >
            <el-option
              v-for="dict in typeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listDept,
  getDept,
  delDept,
  addDept,
  updateDept,
  exportDept,
} from "@/api/medical/dept";
import { listMechanismId } from "@/api/medical/mechanism";
import { listCommunity } from "@/api/medical/community";
import { listMedicalMechanism } from "@/api/medical/mechanism";

export default {
  name: "Dept",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 科室病区表格数据
      deptList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 类别字典
      typeOptions: [],
      // 是否删除字典
      delOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        communityId: null,
        mechanismId: null,
        name: null,
        type: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        communityId: [
          { required: true, message: "请选择医共体", trigger: "blur" },
        ],
        mechanismId: [
          { required: true, message: "请选择医疗机构", trigger: "blur" },
        ],
        name: [{ required: true, message: "请输入科室名称", trigger: "blur" }],
        type: [{ required: true, message: "请选择科室类别", trigger: "blur" }],
      },
      cimmunity: [], //医共体ID
      mechanism: [],
      mechanismArr: [],
    };
  },
  created() {
    this.getList();
    this.getCommunityList();
    //this.getMechanismListArr();
    this.getDicts("dept_type").then((response) => {
      this.typeOptions = response.data;
    });
    this.getDicts("del_state").then((response) => {
      this.delOptions = response.data;
    });
  },
  watch: {
    'queryParams.communityId' (val) {
      this.getMechanismListArr(val)
    }
  },
  methods: {
    /** 查询科室病区列表 */
    getList() {
      this.loading = true;
      listDept(this.queryParams).then((response) => {
        this.deptList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询医共体列表 */
    getCommunityList() {
      listCommunity().then((response) => {
        this.cimmunity = response.rows;
      });
    },
    /** 通过医共体id查询机构 **/
    handleChangeCommunity() {
      if (this.form.communityId) {
        this.getMechanismList(this.form.communityId);
        this.form.mechanismId = null;
      }
    },
    getMechanismListArr(val) {
      listMechanismId(val).then((response) => {
        this.mechanismArr = response.data;
      });
    },
    /** 查询医疗机构名称 **/
    getMechanismList(id) {
      listMechanismId(id).then((response) => {
        this.mechanism = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        communityId: null,
        mechanismId: null,
        name: null,
        type: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null,
        del: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加科室病区";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getDept(id).then((response) => {
        this.form = response.data;
        this.getMechanismList(this.form.communityId);
        this.open = true;
        this.title = "修改科室病区";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateDept(this.form).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDept(this.form).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm("确定需要删除已选数据吗？", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delDept(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有科室病区数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.exportLoading = true;
          return exportDept(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
